// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "schedio.h"
#include "add.h"

void add_parcourir(GtkWidget *entry)
{
    GtkWidget *parcourir = NULL;
    char *filename;

    parcourir = gtk_file_chooser_dialog_new_with_backend ("Sélection du fichier de configuration",NULL,GTK_FILE_CHOOSER_ACTION_OPEN,".conf",GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, "Sélectionner", GTK_RESPONSE_ACCEPT,NULL);

    if (gtk_dialog_run (GTK_DIALOG (parcourir)) == GTK_RESPONSE_ACCEPT)
      {
        filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (parcourir));

        fprintf(stderr,"%s\n",filename);

        gtk_entry_set_text(entry,filename);

        g_free (filename);
      }
    gtk_widget_destroy (parcourir);
}

void add_parcourir1(GtkWidget *entry)
{
    GtkWidget *parcourir = NULL;
    char *filename;

    parcourir = gtk_file_chooser_dialog_new_with_backend ("Création du fichier de configuration",NULL,GTK_FILE_CHOOSER_ACTION_SAVE,".conf",GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, "Créer", GTK_RESPONSE_ACCEPT,NULL);

    if (gtk_dialog_run (GTK_DIALOG (parcourir)) == GTK_RESPONSE_ACCEPT)
      {
        filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (parcourir));

        fprintf(stderr,"%s\n",filename);

        gtk_entry_set_text(entry,filename);

        g_free (filename);
      }
    gtk_widget_destroy (parcourir);
}

void liststore_add(GSList *list)
{
    GtkListStore *liststore = g_slist_nth_data(list,5);
    GtkTreeIter *treeiter = g_slist_nth_data(list,6);
    GtkWidget *combobox = g_slist_nth_data(list,0);
    GtkWidget *button_charger = g_slist_nth_data(list,1);
    GtkWidget *button_nouveau = g_slist_nth_data(list,2);
    GtkWidget *entry_charger = g_slist_nth_data(list,3);
    GtkWidget *entry_nouveau = g_slist_nth_data(list,4);

    gtk_list_store_append(liststore,treeiter);

    if(gtk_toggle_button_get_active(button_charger))
    {
        gtk_list_store_set (liststore, treeiter,COLUMN_PLUGIN, gtk_combo_box_get_active_text(combobox),COLUMN_SAVE,gtk_entry_get_text(entry_charger),-1);
    }
    else if(gtk_toggle_button_get_active(button_nouveau))
    {
        gtk_list_store_set (liststore, treeiter,COLUMN_PLUGIN, gtk_combo_box_get_active_text(combobox),COLUMN_SAVE,gtk_entry_get_text(entry_nouveau),-1);
    }
}

void Add(GSList *user_data)
{
    FILE *f = NULL;
    char *dir = NULL;
    char test[1000];
    int i=0,eof=0,j=0;
    int length=0;
    add.gslist = NULL;
    add.gslist1 = NULL;

    GtkTreeSelection* selection;
    GtkTreeModel* treemodel;
    GtkTreeView* tree_view;
    GtkTreeIter tree_iter;
    gboolean valid;
    GtkListStore *liststore;
    gchar *str_data;
    gchar *str_data1;

    GtkTreePath *path1;
    GList* list_selected;
    gint num=0;

    length=g_slist_length(user_data);
    if(length==2)
    {
        add.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
        gtk_container_set_border_width (GTK_CONTAINER (add.window),2);
        gtk_window_set_title (GTK_WINDOW (add.window), "Ajouter");
        gtk_window_set_position (GTK_WINDOW (add.window), GTK_WIN_POS_NONE);
        gtk_window_set_icon(GTK_WINDOW(add.window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));
        g_signal_connect (add.window, "destroy", gtk_widget_destroy, add.window);
        //gtk_window_resize(GTK_WINDOW(add.window),300,300);

        add.container.table = gtk_table_new(10,4,FALSE);

        add.label.plugin = gtk_label_new("Plugin à utiliser: ");
        gtk_table_attach_defaults(add.container.table,add.label.plugin,2,4,0,1);

        system("ls /usr/share/schedio/plugin > $HOME/.schedio/tmp/tmp.tmp");

        dir = malloc(strlen(pwd)+sizeof("/.schedio/tmp/tmp.tmp"));
        strcpy(dir,pwd);
        strcat(dir,"/.schedio/tmp/tmp.tmp");

        f = fopen(dir,"r");

        add.combobox.plugin = gtk_combo_box_new_text();

        fgets(test,1000,f);
        eof=feof(f);
        while(!eof)
        {
            j=0;
            while(test[j]!='\n') j++;
            test[j]='\0';
            gtk_combo_box_append_text(GTK_COMBO_BOX(add.combobox.plugin),test);
            i++;
            fgets(test,1000,f);
            eof=feof(f);
        }

        fclose(f);

        if(i==0) gtk_combo_box_append_text(GTK_COMBO_BOX(add.combobox.plugin),"no-plugin found");

        gtk_combo_box_set_active(GTK_COMBO_BOX(add.combobox.plugin),0);
        gtk_table_attach_defaults(add.container.table,add.combobox.plugin,5,10,0,1);

        gtk_table_set_row_spacing(add.container.table,0,50);

        add.radio_button.charger = gtk_radio_button_new_with_label(NULL,"Depuis un fichier paramètre: ");
        gtk_table_attach_defaults(add.container.table,add.radio_button.charger,0,5,1,2);

        add.entry.charger = gtk_entry_new();
        gtk_table_attach_defaults(add.container.table,add.entry.charger,6,9,1,2);

        add.button.parcourir = gtk_button_new_with_label("parcourir");
        gtk_signal_connect_object(GTK_OBJECT(add.button.parcourir), "clicked", add_parcourir, add.entry.charger);
        gtk_table_attach_defaults(add.container.table,add.button.parcourir,9,10,1,2);

        gtk_table_set_row_spacing(add.container.table,1,25);

        add.entry.nouveau = gtk_entry_new();
        gtk_table_attach_defaults(add.container.table,add.entry.nouveau,6,9,2,3);

        add.radio_button.nouveau = gtk_radio_button_new_with_label_from_widget(add.radio_button.charger,"Créer un fichier paramètre: ");
        gtk_table_attach_defaults(add.container.table,add.radio_button.nouveau,0,5,2,3);

        add.button.parcourir1 = gtk_button_new_with_label("parcourir");
        gtk_signal_connect_object(GTK_OBJECT(add.button.parcourir1), "clicked", add_parcourir1, add.entry.nouveau);
        gtk_table_attach_defaults(add.container.table,add.button.parcourir1,9,10,2,3);

        gtk_table_set_row_spacing(add.container.table,2,25);

        add.gslist=g_slist_append(add.gslist,add.combobox.plugin);
        g_slist_append(add.gslist,add.radio_button.charger);
        g_slist_append(add.gslist,add.radio_button.nouveau);
        g_slist_append(add.gslist,add.entry.charger);
        g_slist_append(add.gslist,add.entry.nouveau);

        add.gslist1=g_slist_append(add.gslist1,add.combobox.plugin);
        g_slist_append(add.gslist1,add.radio_button.charger);
        g_slist_append(add.gslist1,add.radio_button.nouveau);
        g_slist_append(add.gslist1,add.entry.charger);
        g_slist_append(add.gslist1,add.entry.nouveau);
        g_slist_append(add.gslist1,g_slist_nth_data(user_data,0));
        g_slist_append(add.gslist1,g_slist_nth_data(user_data,1));


        add.button.launch = gtk_button_new_with_label("Lancer");
        gtk_table_attach_defaults(add.container.table,add.button.launch,2,5,3,4);
        gtk_signal_connect_object(GTK_OBJECT(add.button.launch), "clicked", liststore_add, add.gslist1);
        gtk_signal_connect_object(GTK_OBJECT(add.button.launch), "clicked", plugin_load, add.gslist);

        gtk_signal_connect_object(GTK_OBJECT(add.button.launch), "clicked", gtk_widget_destroy, add.window);

        add.button.cancel = gtk_button_new_with_label("Annuler");
        gtk_table_attach_defaults(add.container.table,add.button.cancel,5,8,3,4);
        gtk_signal_connect_object(GTK_OBJECT(add.button.cancel), "clicked", gtk_widget_destroy, add.window);

        gtk_container_add(add.window,add.container.table);

        if(i==0)
        {
            gtk_widget_set_sensitive(add.combobox.plugin,FALSE);
            gtk_widget_set_sensitive(add.button.launch,FALSE);
        }
        gtk_widget_show_all(add.window);
    }
    else if(length==3)
    {
        liststore = (GtkListStore*)g_slist_nth_data(user_data,0);
        tree_view = (GtkTreeView*)g_slist_nth_data(user_data,2);

        selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(tree_view));
        treemodel=gtk_tree_view_get_model (GTK_TREE_VIEW(tree_view));

        list_selected=gtk_tree_selection_get_selected_rows (selection,&treemodel);
        path1=g_list_nth_data(list_selected,0);

        if(path1!=NULL)
        {
            num = gtk_tree_path_get_indices (path1)[0];
        }

        valid=gtk_tree_selection_get_selected(selection,&treemodel,&tree_iter);

        if(valid)
        {
            gtk_tree_model_get (liststore, &tree_iter,
                      COLUMN_PLUGIN, &str_data,
                      COLUMN_SAVE, &str_data1,
                      -1);
            add.entry.charger = gtk_entry_new();
            add.entry.nouveau = gtk_entry_new();
            add.radio_button.charger = gtk_radio_button_new_with_label(NULL,"Depuis un fichier paramètre: ");
            add.radio_button.nouveau = gtk_radio_button_new_with_label_from_widget(add.radio_button.charger,"Créer un fichier paramètre: ");
            gtk_toggle_button_set_active(add.radio_button.charger,TRUE);

            add.combobox.plugin = gtk_combo_box_new_text();
            gtk_combo_box_append_text(GTK_COMBO_BOX(add.combobox.plugin),str_data);
            gtk_combo_box_set_active(GTK_COMBO_BOX(add.combobox.plugin),0);

            gtk_entry_set_text(add.entry.charger,str_data1);

            add.gslist1=g_slist_append(add.gslist1,add.combobox.plugin);
            g_slist_append(add.gslist1,add.radio_button.charger);
            g_slist_append(add.gslist1,add.radio_button.nouveau);
            g_slist_append(add.gslist1,add.entry.charger);
            g_slist_append(add.gslist1,add.entry.nouveau);
            g_slist_append(add.gslist1,g_slist_nth_data(user_data,0));
            g_slist_append(add.gslist1,g_slist_nth_data(user_data,1));
            g_slist_append(add.gslist1,num);
            plugin_load(add.gslist1);
        }
    }
}

void Add_ncy()
{
    FILE *f = NULL;
    char *dir = NULL;
    char test[1000];
    int i=0,eof=0,j=0;
    add.gslist = NULL;

    add.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (add.window),2);
    gtk_window_set_title (GTK_WINDOW (add.window), "Scripts non-cyclique");
    gtk_window_set_position (GTK_WINDOW (add.window), GTK_WIN_POS_NONE);
    gtk_window_set_icon(GTK_WINDOW(add.window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));
    g_signal_connect (add.window, "destroy", gtk_widget_destroy, add.window);

    add.container.table = gtk_table_new(10,4,FALSE);

    add.label.plugin = gtk_label_new("Plugin à utiliser: ");
    gtk_table_attach_defaults(add.container.table,add.label.plugin,2,4,0,1);

    system("ls /usr/share/schedio/plugin_ncy > $HOME/.schedio/tmp/tmp.tmp");

    dir = malloc(strlen(pwd)+sizeof("/.schedio/tmp/tmp.tmp"));
    strcpy(dir,pwd);
    strcat(dir,"/.schedio/tmp/tmp.tmp");

    f = fopen(dir,"r");

    add.combobox.plugin = gtk_combo_box_new_text();

    fgets(test,1000,f);
    eof=feof(f);
    while(!eof)
    {
        j=0;
        while(test[j]!='\n') j++;
        test[j]='\0';
        gtk_combo_box_append_text(GTK_COMBO_BOX(add.combobox.plugin),test);
        i++;
        fgets(test,1000,f);
        eof=feof(f);
    }

    fclose(f);

    if(i==0) gtk_combo_box_append_text(GTK_COMBO_BOX(add.combobox.plugin),"aucun plugin installé");

    gtk_combo_box_set_active(GTK_COMBO_BOX(add.combobox.plugin),0);
    gtk_table_attach_defaults(add.container.table,add.combobox.plugin,5,10,0,1);

    gtk_table_set_row_spacing(add.container.table,0,50);

    add.radio_button.charger = gtk_radio_button_new_with_label(NULL,"Depuis un fichier paramètre: ");
    gtk_table_attach_defaults(add.container.table,add.radio_button.charger,0,5,1,2);

    add.entry.charger = gtk_entry_new();
    gtk_table_attach_defaults(add.container.table,add.entry.charger,6,9,1,2);

    add.button.parcourir = gtk_button_new_with_label("parcourir");
    gtk_signal_connect_object(GTK_OBJECT(add.button.parcourir), "clicked", add_parcourir, add.entry.charger);
    gtk_table_attach_defaults(add.container.table,add.button.parcourir,9,10,1,2);

    gtk_table_set_row_spacing(add.container.table,1,25);

    add.entry.nouveau = gtk_entry_new();
    gtk_table_attach_defaults(add.container.table,add.entry.nouveau,6,9,2,3);

    add.radio_button.nouveau = gtk_radio_button_new_with_label_from_widget(add.radio_button.charger,"Créer un fichier paramètre: ");
    gtk_table_attach_defaults(add.container.table,add.radio_button.nouveau,0,5,2,3);

    add.button.parcourir1 = gtk_button_new_with_label("parcourir");
    gtk_signal_connect_object(GTK_OBJECT(add.button.parcourir1), "clicked", add_parcourir1, add.entry.nouveau);
    gtk_table_attach_defaults(add.container.table,add.button.parcourir1,9,10,2,3);

    gtk_table_set_row_spacing(add.container.table,2,25);

    add.gslist=g_slist_append(add.gslist,add.combobox.plugin);
    g_slist_append(add.gslist,add.radio_button.charger);
    g_slist_append(add.gslist,add.radio_button.nouveau);
    g_slist_append(add.gslist,add.entry.charger);
    g_slist_append(add.gslist,add.entry.nouveau);


    add.button.launch = gtk_button_new_with_label("Lancer");
    gtk_table_attach_defaults(add.container.table,add.button.launch,2,5,3,4);
    gtk_signal_connect_object(GTK_OBJECT(add.button.launch), "clicked", plugin_ncy_load, add.gslist);
    gtk_signal_connect_object(GTK_OBJECT(add.button.launch), "clicked", gtk_widget_destroy, add.window);

    add.button.cancel = gtk_button_new_with_label("Annuler");
    gtk_table_attach_defaults(add.container.table,add.button.cancel,5,8,3,4);
    gtk_signal_connect_object(GTK_OBJECT(add.button.cancel), "clicked", gtk_widget_destroy, add.window);

    gtk_container_add(add.window,add.container.table);

    if(i==0)
    {
        gtk_widget_set_sensitive(add.combobox.plugin,FALSE);
        gtk_widget_set_sensitive(add.button.launch,FALSE);
    }
    gtk_widget_show_all(add.window);
}

