// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PLUGIN_H
#define PLUGIN_H
#include <gtk/gtk.h>

int* type;
int nb_type;

void interface_load(GString *script_file,GString *plugin_file,GString *mode,GString *save_file,GString* visual_string,gint is_modifying); // Construit la fenêtre
void interface_load_ncy(GString *script_file,GString *plugin_file,GString *mode,GString *save_file); // Construit la fenêtre en ncy
void plugin_load(GSList* list); // Choix de l'interface
void plugin_ncy_load(GSList* list); // Choix de l'interface en ncy
char* simple_extract(char* line); // Extrait ce qui se trouve entre balises
char* keep_name(char* line); // extrait le nom de la balise
char* keep_param(char* line); // extrait les paramètres d'une balise
int widget_count(char* file,int* nb_entry,int* nb_spin,int* nb_check,int* nb_combo,int* nb_scale,int* nb_radio,int* nb_toggle,int* nb_box_toggle); // compte le nombre de widget selon leur type
int param_count(char* param); // Compte le nombre de paramètres que contient une balise
char* param_extract(char*param, int num); // Extrait un paramètre selon son emplacement dans la balise

struct plugin_container{
    GtkWidget* scroll;
    GtkWidget* VBox;
    GtkWidget* hbox;
};

struct plugin{
    GtkWidget *window;
    struct plugin_container container;
    GtkWidget* label;
    GtkWidget** entry;
    GtkWidget* widget_label;
    GtkWidget** spin;
    GtkWidget** check;
    GtkWidget** combo;
    GtkWidget** scale;
    GtkWidget** radio;
    GtkWidget** toggle;
    GtkWidget** confirm;
};

struct plugin plugin;

#endif
