// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "schedio.h"
#include "add.h"
#include "file.h"
#include "visual.h"
#include "about.h"

void schedio_destroy()
{
    int nb_line=0;
    int i=0;
    GString* file_string=NULL;
    file_string=g_string_new(pwd);
    g_string_append(file_string,"/.schedio/liststore.tmp");

    nb_line=nb_liststore_line;

    while(i<nb_line)
    {
        del_to_quit();
        i++;
    }

    free(g_string_free(file_string,FALSE));
    gtk_main_quit();
}

static void trayIconPopup(GtkStatusIcon *status_icon, guint button, guint32 activate_time, gpointer popUpMenu)
{
    gtk_menu_popup(GTK_MENU(popUpMenu), NULL, NULL, gtk_status_icon_position_menu, status_icon, button, activate_time);
}

static void set_check_false(GtkCheckMenuItem *show)
{
    gtk_check_menu_item_set_active(show,FALSE);
}

static void togglestate(GtkMenuItem *check,gpointer window)
{
    if(gtk_check_menu_item_get_active(check))
    {
        gtk_widget_show_all(window);
    }
    else
    {
        gtk_widget_hide_all(window);
    }
}

GdkPixbuf *create_pixbuf(const gchar * filename)
{
   GdkPixbuf *pixbuf;
   GError *error = NULL;
   pixbuf = gdk_pixbuf_new_from_file(filename, &error);
   if(!pixbuf) {
      fprintf(stderr, "%s\n", error->message);
      g_error_free(error);
   }

   return pixbuf;
}

void save_startup(GSList *list)
{
    GSList *win = g_slist_nth_data(list,0);
    GSList *data = g_slist_nth_data(list,4);

    GString *combo = NULL;
    GString *entry = NULL;

    int i = 1;

    FILE *f = NULL;

    char *dir =  NULL;

    dir = malloc(strlen(pwd)+sizeof("/.schedio/startup/startup.conf"));
    strcpy(dir,pwd);
    strcat(dir,"/.schedio/startup/startup.conf");

    f = fopen(dir,"w");

    for(i=1;(i+2)<=g_slist_length(data);i+=3)
    {
        combo = g_slist_nth_data(data,i+1);
        entry = g_slist_nth_data(data,i+2);

        fprintf(f,"%s,",combo->str);
        fprintf(f,"%s\n",entry->str);
    }

    fclose(f);

    g_slist_free(data);
    g_slist_free(list);

    gtk_widget_destroy(win);
}

void remove_startup_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *hbox = g_slist_nth_data(list,2);
    GtkWidget *label = g_slist_nth_data(list,3);
    GtkWidget *remove = g_slist_nth_data(list,4);
    GSList *data = g_slist_nth_data(list,5);
    int index;
    GSList *data1=NULL,*data2=NULL;

    fprintf(stderr,"******************* hbox is at %x ********************\n",hbox);
    gtk_container_remove(vbox,hbox);
    fprintf(stderr,"******************* label is at %x ********************\n",label);
    gtk_container_remove(hbox,label);
    fprintf(stderr,"******************* remove is at %x ********************\n",remove);
    gtk_container_remove(hbox,remove);

    index = g_slist_index(data,label);

    data1 = g_slist_nth_data(data,index+1);
    data2 = g_slist_nth_data(data,index+2);

    fprintf(stderr,"******************* index is %d ********************\n\n\n",index);

    if(index!=-1)
    {
        fprintf(stderr,"removing...\n");
        g_slist_remove(data,label);
        g_slist_remove(data,data1);
        g_slist_remove(data,data2);
    }

    gtk_window_resize(GTK_WINDOW(win),300,100);
    gtk_widget_show_all(win);
}

int get_char_pos(char *string,char c)
{
    int i=0;

    while(string[i]!=c && string[i]!='\0')i++;
    if((string[i]=='\0'))i=-1;

    return i;
}

void load_startup_file(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *plugin = g_slist_nth_data(list,2);
    GtkWidget *config = g_slist_nth_data(list,3);
    GSList *data = g_slist_nth_data(list,4);

    GString *s_plugin=NULL;

    GString *s_combobox=NULL;
    GString *s_entry=NULL;
    GString *s_line=NULL;

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *hbox=NULL;

    GSList *list_remove = NULL;

    int i = 1,eof;
    int separator_pos=0;

    FILE *f = NULL;

    char *dir =  NULL;
    char *line = NULL;
    char *line2 = NULL;


    dir = malloc(strlen(pwd)+sizeof("/.schedio/startup/startup.conf"));
    strcpy(dir,pwd);
    strcat(dir,"/.schedio/startup/startup.conf");

    f = fopen(dir,"r");
    eof=feof(f);

    while((f!=NULL)&&(!eof)&&(separator_pos!=-1))
    {
        s_combobox=NULL;
        s_entry=NULL;

        line = malloc(500*sizeof(char));
        line2 = malloc(500*sizeof(char));
        if(fgets(line, 500, f)==NULL)break;

        fprintf(stderr,"chaine lue : %s\n",line);

        if(get_char_pos(line,'\n')!=-1)line[get_char_pos(line,'\n')]='\0';
        strcpy(line2,line);

        s_combobox = g_string_new(line);
        s_entry = g_string_new(line2);

        separator_pos = get_char_pos(line,',');
        fprintf(stderr,"pos %d\n",separator_pos);

        if(separator_pos!=-1)
        {
            //fprintf(stderr,"plug combo : %d\n",s_entry->len);
            s_entry = g_string_erase(s_entry,0,separator_pos+1);
            s_combobox = g_string_truncate(s_combobox,separator_pos);

            //fprintf(stderr,"plug combo : %s\n",s_combobox->str);
            //fprintf(stderr,"plug entry: %s\n",s_entry->str);

            s_plugin = g_string_new(s_combobox->str);
            g_string_append(s_plugin," : ");
            g_string_append(s_plugin,s_entry->str);

            label = NULL;
            remove = NULL;
            hbox = NULL;

            label = gtk_label_new(s_plugin->str);
            remove = gtk_button_new_with_label(" - ");
            hbox = gtk_hbox_new(FALSE,6);
            list_remove = NULL;

            g_slist_append(data,label);
            g_slist_append(data,s_combobox);
            g_slist_append(data,s_entry);

            list_remove = g_slist_append(list_remove,win);
            g_slist_append(list_remove,vbox);
            g_slist_append(list_remove,hbox);
            g_slist_append(list_remove,label);
            g_slist_append(list_remove,remove);
            g_slist_append(list_remove,data);

            gtk_container_add(GTK_CONTAINER(vbox),hbox);
            gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
            gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_startup_item, list_remove);
            gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);

            eof=feof(f);
       }

        free(line);
    }

    fclose(f);

}

void add_startup_item(GSList *list)
{
    GtkWidget *win = g_slist_nth_data(list,0);
    GtkWidget *vbox = g_slist_nth_data(list,1);
    GtkWidget *plugin = g_slist_nth_data(list,2);
    GtkWidget *config = g_slist_nth_data(list,3);
    GSList *data = g_slist_nth_data(list,4);

    GString *s_plugin=NULL;

    GString *s_combobox=NULL;
    GString *s_entry=NULL;

    GtkWidget *label=NULL;
    GtkWidget *remove=NULL;
    GtkWidget *hbox=NULL;

    GSList *list_remove = NULL;

    s_plugin = g_string_new(gtk_combo_box_get_active_text(plugin));
    g_string_append(s_plugin," : ");
    g_string_append(s_plugin,gtk_entry_get_text(config));

    s_combobox = g_string_new(gtk_combo_box_get_active_text(plugin));
    s_entry = g_string_new(gtk_entry_get_text(config));

    if(strlen(s_entry->str)>2)
    {
        label = gtk_label_new(s_plugin->str);
        remove = gtk_button_new_with_label(" - ");
        hbox = gtk_hbox_new(FALSE,6);

        g_slist_append(data,label);
        g_slist_append(data,s_combobox);
        g_slist_append(data,s_entry);

        list_remove = g_slist_append(list_remove,win);
        g_slist_append(list_remove,vbox);
        g_slist_append(list_remove,hbox);
        g_slist_append(list_remove,label);
        g_slist_append(list_remove,remove);
        g_slist_append(list_remove,data);

        gtk_container_add(GTK_CONTAINER(vbox),hbox);
        gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
        gtk_signal_connect_object(GTK_OBJECT(remove), "clicked", remove_startup_item, list_remove);
        gtk_box_pack_start (GTK_BOX (hbox), remove, FALSE, FALSE, 0);


        gtk_window_resize(GTK_WINDOW(win),300,100);
        gtk_widget_show_all(win);
    }
}

void show_startup_configurator(GtkButton *button, gpointer user_data)///A la fin de cette fonction ajouter un destructeur pour free des GArray?? si nécessaire (fuites de mémoire)
{
    GtkWidget *win = NULL;
    GtkWidget *label = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GtkWidget *text = NULL;
    GtkWidget *combobox = NULL;

    GtkWidget *plugin_name = NULL;
    GtkWidget *config_file = NULL;

    GtkWidget *plugin_combo = NULL;
    GtkWidget *config_entry = NULL;

    GtkWidget *frame = NULL;
    GtkWidget *set = NULL;
    GtkWidget *vbox_plugins = NULL;
    GtkWidget *valid = NULL;
    GtkWidget *planning_hbox = NULL;
    GtkWidget *planning_label = NULL;
    GtkWidget *planning_remove = NULL;
    GtkWidget *parcourir = NULL;
    GArray *tab_index = NULL;

    char *dir = NULL;
    char test[1000];
    FILE *f = NULL;

    int i=0,j=0,eof=0;

    GSList *list = NULL;
    GSList *data = g_slist_alloc();

    win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    gtk_window_set_title (GTK_WINDOW (win), "Editeur");
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
    gtk_window_set_default_size(GTK_WINDOW(win),300,100);

    gtk_widget_realize (win);
    g_signal_connect (win, "destroy", gtk_widget_destroy, NULL);

    vbox = gtk_vbox_new(FALSE,6);
    gtk_container_add (GTK_CONTAINER (win), vbox);

    frame = gtk_frame_new("Programmes gérés ");
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

    vbox_plugins = gtk_vbox_new(FALSE,6);
    gtk_container_add(frame,vbox_plugins);

    hbox = gtk_hbox_new(FALSE,6);
    gtk_container_add(GTK_CONTAINER(vbox),hbox);

    text = gtk_label_new("Plugin :");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    system("ls /usr/share/schedio/plugin > $HOME/.schedio/tmp/tmp.tmp");

    dir = malloc(strlen(pwd)+sizeof("/.schedio/tmp/tmp.tmp"));
    strcpy(dir,pwd);
    strcat(dir,"/.schedio/tmp/tmp.tmp");

    f = fopen(dir,"r");

    plugin_combo = gtk_combo_box_new_text();

    fgets(test,1000,f);
    eof=feof(f);
    while(!eof)
    {
        j=0;
        while(test[j]!='\n') j++;
        test[j]='\0';
        gtk_combo_box_append_text(GTK_COMBO_BOX(plugin_combo),test);
        i++;
        fgets(test,1000,f);
        eof=feof(f);
    }

    fclose(f);

    if(i==0) gtk_combo_box_append_text(GTK_COMBO_BOX(plugin_combo),"no-plugin found");

    gtk_combo_box_set_active(GTK_COMBO_BOX(plugin_combo),0);
    gtk_box_pack_start (GTK_BOX(hbox),plugin_combo,FALSE,FALSE,0);

    text = gtk_label_new("Fichier de configuration :");
    gtk_box_pack_start (GTK_BOX (hbox), text, FALSE, FALSE, 0);

    config_entry = gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(hbox),config_entry,FALSE,FALSE,0);

    parcourir = gtk_button_new_with_label("...");
    gtk_signal_connect_object(GTK_OBJECT(parcourir), "clicked", add_parcourir, config_entry);
    gtk_box_pack_start(GTK_BOX(hbox),parcourir,FALSE,FALSE,0);

    list = g_slist_append(list,(gpointer)win);
    g_slist_append(list,(gpointer)vbox_plugins);
    g_slist_append(list,(gpointer)plugin_combo);
    g_slist_append(list,(gpointer)config_entry);
    g_slist_append(list,(gpointer)data);

    set = gtk_button_new_with_label(" + ");
    gtk_signal_connect_object(GTK_OBJECT(set), "clicked", add_startup_item, list);
    gtk_box_pack_start (GTK_BOX (hbox), set, FALSE, FALSE, 0);

    valid = gtk_button_new_with_label("Valider");
    gtk_signal_connect_object(GTK_OBJECT(valid), "clicked", save_startup, list);
    gtk_box_pack_start (GTK_BOX (vbox), valid, FALSE, FALSE, 0);

    load_startup_file(list);

    gtk_widget_show_all (win);
}

int Schedio_init(void)
{
    struct schedio *schedio;

    schedio = malloc(sizeof(struct schedio));
    nb_liststore_line=0;

    schedio->window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (schedio->window),2);
    gtk_window_set_title (GTK_WINDOW (schedio->window), "Schedio");
    gtk_window_set_position (GTK_WINDOW (schedio->window), GTK_WIN_POS_CENTER);
    gtk_window_resize(GTK_WINDOW(schedio->window),500,350);
    gtk_widget_realize (schedio->window);
    gtk_window_set_icon(GTK_WINDOW(schedio->window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));
    schedio->status = gtk_status_icon_new_from_file ("/usr/share/pixmaps/s_schedio.png");
    gtk_status_icon_set_tooltip (schedio->status,"Schedio");
    g_signal_connect (schedio->window, "destroy", schedio_destroy, NULL);

    GSList *list=NULL;
    GSList *list_modify=NULL;

    /** Begin System Tray Menu **/

    schedio->menutray = gtk_menu_new();

    schedio->menuitem.show = gtk_check_menu_item_new_with_label("Visible");
    gtk_menu_shell_append(GTK_MENU_SHELL(schedio->menutray), schedio->menuitem.show);
    if(schedio_visible==1)gtk_check_menu_item_set_active (schedio->menuitem.show,TRUE);
    g_signal_connect(G_OBJECT(schedio->menuitem.show),"toggled",G_CALLBACK(togglestate),(gpointer)schedio->window);

    schedio->menuitem.close = gtk_menu_item_new_with_label ("Fermer");
    gtk_menu_shell_append(GTK_MENU_SHELL(schedio->menutray), schedio->menuitem.close);
    //g_signal_connect(G_OBJECT(schedio->menuitem.close),"activate",Schedio_destroy,NULL);
    g_signal_connect(G_OBJECT(schedio->menuitem.close),"activate",gtk_main_quit,NULL);

    gtk_widget_show_all (schedio->menutray);

    g_signal_connect(GTK_STATUS_ICON (schedio->status), "popup-menu", GTK_SIGNAL_FUNC (trayIconPopup), schedio->menutray);
    //gtk_signal_connect_object (GTK_OBJECT(schedio->window), "delete-event", GTK_SIGNAL_FUNC(set_check_false),schedio->menuitem.show);
    //g_signal_connect (schedio->window, "delete-event", gtk_widget_hide_on_delete,NULL);

    /** End System Tray Menu **/

    schedio->list.liststore = gtk_list_store_new(N_COLUMNS, G_TYPE_STRING,G_TYPE_STRING);
    //open_config(schedio->list.liststore,&(schedio->list.treeiter));

    schedio->list.treeview = gtk_tree_view_new_with_model (GTK_TREE_MODEL(schedio->list.liststore));

    schedio->list.renderer = gtk_cell_renderer_text_new ();
    schedio->list.column = gtk_tree_view_column_new_with_attributes ("Plugin",
                                                       schedio->list.renderer,
                                                       "text",COLUMN_PLUGIN,
                                                       NULL);
    gtk_tree_view_append_column (GTK_TREE_VIEW (schedio->list.treeview), schedio->list.column);

    schedio->list.renderer = gtk_cell_renderer_text_new ();
    schedio->list.column = gtk_tree_view_column_new_with_attributes ("Fichier de sauvegarde",
                                                       schedio->list.renderer,
                                                       "text",COLUMN_SAVE,
                                                       NULL);
    gtk_tree_view_append_column (GTK_TREE_VIEW (schedio->list.treeview), schedio->list.column);

    // Add the scrollabled capabilities
    schedio->list.scroll=gtk_scrolled_window_new(NULL,NULL);
    gtk_scrolled_window_set_policy(schedio->list.scroll,GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
    gtk_container_add(GTK_CONTAINER(schedio->list.scroll),schedio->list.treeview);

    //GSLIST del
    gslist_del = g_slist_append(gslist_del,(gpointer)(schedio->list.liststore));
    g_slist_append(gslist_del,(gpointer)schedio->list.treeview);

    //GSLIST list_modify
    list_modify = g_slist_append(list_modify,(gpointer)(schedio->list.liststore));
    g_slist_append(list_modify,&(schedio->list.treeiter));
    g_slist_append(list_modify,schedio->list.treeview);

    // GSLIST list (add)

    list = g_slist_append(list,schedio->list.liststore);
    g_slist_append(list,&(schedio->list.treeiter));

    // GSLIST modify (row-activated)

    schedio->button.gslist_add = NULL;
    schedio->button.gslist_add = g_slist_append(schedio->button.gslist_add,(gpointer)(schedio->list.liststore));
    g_slist_append(schedio->button.gslist_add,&(schedio->list.treeiter));
    g_slist_append(schedio->button.gslist_add,schedio->list.treeview);

    // Connect the list to the Add window
    g_signal_connect (G_OBJECT (schedio->list.treeview), "row-activated", G_CALLBACK (List_Clicked), (gpointer)schedio->button.gslist_add);

    /* Create a vertical box with buttons */

    schedio->container.vbox1 = gtk_vbox_new (FALSE, 2);
    gtk_container_add (GTK_CONTAINER (schedio->window), schedio->container.vbox1);

    gtk_box_pack_start (GTK_BOX (schedio->container.vbox1), schedio->list.scroll, TRUE, TRUE, 0);

    schedio->container.vbox2 = gtk_vbox_new(FALSE,6);
    schedio->container.hbox = gtk_hbox_new(TRUE,3);
    schedio->container.hbox1 = gtk_hbox_new(TRUE,3);
    schedio->container.hbox2 = gtk_hbox_new(TRUE,3);

    schedio->button.add = gtk_button_new_with_label("Ajouter");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.add), "clicked", GTK_SIGNAL_FUNC(Add), list);
    gtk_box_pack_start (GTK_BOX (schedio->container.hbox1), schedio->button.add, TRUE, TRUE, 0);

    schedio->button.modify = gtk_button_new_with_label("Modifier");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.modify), "clicked", GTK_SIGNAL_FUNC(Add), list_modify);
    gtk_box_pack_start (GTK_BOX (schedio->container.hbox1), schedio->button.modify, TRUE, TRUE, 0);

    gtk_box_pack_start(GTK_BOX(schedio->container.vbox2),schedio->container.hbox1,FALSE,FALSE,0);

    schedio->button.del = gtk_button_new_with_label("Supprimer");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.del), "clicked", GTK_SIGNAL_FUNC(del),(GSList*)gslist_del);
    gtk_box_pack_start (GTK_BOX (schedio->container.hbox), schedio->button.del, TRUE, TRUE, 0);

    schedio->button.clear = gtk_button_new_with_label("Vider");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.clear), "clicked", GTK_SIGNAL_FUNC(clear), (GtkListStore *)schedio->list.liststore);
    gtk_box_pack_start (GTK_BOX (schedio->container.hbox), schedio->button.clear, TRUE, TRUE, 0);

    gtk_box_pack_start(GTK_BOX(schedio->container.vbox2),schedio->container.hbox,FALSE,FALSE,0);

    schedio->button.visualize = gtk_button_new_with_label("Visualiser");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.visualize), "clicked", GTK_SIGNAL_FUNC(visualisation), list_modify);
    gtk_box_pack_start (GTK_BOX (schedio->container.vbox2), schedio->button.visualize, TRUE, FALSE, 0);

    schedio->button.non_cly = gtk_button_new_with_label("Scripts non cycliques");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.non_cly), "clicked", GTK_SIGNAL_FUNC(Add_ncy), NULL);
    gtk_box_pack_start (GTK_BOX (schedio->container.hbox2), schedio->button.non_cly, TRUE, TRUE, 0);

    schedio->button.startup = gtk_button_new_with_label("Configuration au démarrage");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.startup), "clicked", GTK_SIGNAL_FUNC(show_startup_configurator), 0);
    gtk_box_pack_start (GTK_BOX (schedio->container.hbox2), schedio->button.startup, TRUE, TRUE, 0);

    gtk_box_pack_start(GTK_BOX(schedio->container.vbox2),schedio->container.hbox2,FALSE,FALSE,0);

    schedio->button.about = gtk_button_new_with_label("À propos");
    gtk_signal_connect_object(GTK_OBJECT(schedio->button.about), "clicked", GTK_SIGNAL_FUNC(about), NULL);
    gtk_box_pack_start (GTK_BOX (schedio->container.vbox2), schedio->button.about, TRUE, FALSE, 0);

    schedio->button.quit = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
    g_signal_connect (schedio->button.quit, "clicked", schedio_destroy, NULL);
    //tk_signal_connect_object (GTK_OBJECT(schedio->button.quit), "clicked", gtk_main_quit, NULL);
    gtk_box_pack_start (GTK_BOX (schedio->container.vbox2), schedio->button.quit, TRUE, FALSE,0);

    gtk_box_pack_start(GTK_BOX(schedio->container.vbox1),schedio->container.vbox2,FALSE,FALSE,0);

    /** Schedio's window config **/
    if(schedio_visible==1)gtk_widget_show_all (schedio->window);

    schedio_startup(schedio->list.liststore,&(schedio->list.treeiter));

    return 0;
}

void List_Clicked(GtkTreeView *tree_view, GtkTreePath *path1, GtkTreeViewColumn *column, gpointer data)
{
    GSList *gslist_add=(GSList*)data;

    Add(gslist_add);
}

void clear(GtkListStore* liststore)
{
    gtk_list_store_clear(liststore);
}

void del(gpointer data)
{

    GSList *gslist_del=(GSList*)data;
    GtkTreeSelection* selection;
    GtkTreeModel* treemodel;
    GtkTreeView* tree_view;
    GtkTreeIter tree_iter;
    GtkTreePath *path1;
    GList* list_selected;
    GString* dir;

    gboolean row;
    int num=0;
    int pid;
    GString* visual_string=NULL;
    GString* cmd=NULL;
    GString* file=NULL;
    char conv[1000];

    FILE* f1=NULL;
    char test[1000];

    GtkListStore *liststore = (GtkListStore*)g_slist_nth_data(gslist_del,0);
    tree_view = (GtkTreeView*)g_slist_nth_data(gslist_del,1);

    selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(tree_view));
    treemodel=gtk_tree_view_get_model (GTK_TREE_VIEW(tree_view));

    list_selected=gtk_tree_selection_get_selected_rows (selection,&treemodel);
    path1=g_list_nth_data(list_selected,0);

    row=gtk_tree_selection_get_selected(selection,&treemodel,&tree_iter);

    if(path1!=NULL && row)
    {
        num = gtk_tree_path_get_indices (path1)[0];
        gtk_list_store_remove(liststore,&tree_iter);
        file=g_string_new(pwd);
        g_string_append(file,"/.schedio/liststore.tmp");
        pid=get_pid(file->str,num);
        visual_string=get_visual_name(file->str,num);

        f1=fopen(file->str,"r");
        free(g_string_free(file,FALSE));
        fgets(test,1000,f1);
        printf("%s\n",test);
        fclose(f1);
        cmd=g_string_new("rm ");
        g_string_append(cmd,visual_string->str);
        system(cmd->str);
        free(g_string_free(visual_string,FALSE));
        free(g_string_free(cmd,FALSE));

        if(pid!=0)
        {
            cmd=g_string_new("kill ");
            sprintf(conv,"%d",pid);
            g_string_append(cmd,conv);
            system(cmd->str);
            free(g_string_free(cmd,FALSE));
        }
    }
    if(path1!=NULL && row)
    {
        dir=g_string_new(pwd);
        g_string_append(dir,"/.schedio/liststore.tmp");
        del_line(dir->str,num);

        free(g_string_free(dir,FALSE));
    }
}

void del_to_quit()
{
    GString* dir;
    int pid;
    GString* cmd=NULL;
    GString* file=NULL;
    char conv[1000];

    file=g_string_new(pwd);
    g_string_append(file,"/.schedio/liststore.tmp");
    pid=get_pid(file->str,0);

    if(pid!=0)
    {
        cmd=g_string_new("kill ");
        sprintf(conv,"%d",pid);
        g_string_append(cmd,conv);
        system(cmd->str);
        free(g_string_free(cmd,FALSE));
    }

    dir=g_string_new(pwd);
    g_string_append(dir,"/.schedio/liststore.tmp");
    del_line(dir->str,0);

    free(g_string_free(dir,FALSE));
}

int schedio_startup(GtkListStore *liststore,GtkTreeIter *treeiter)
{
    FILE* f=NULL;
    FILE* f_visual=NULL;
    GString* file_name=NULL;
    short eof=0;
    char line[1000];
    char plugin[1000];
    char file_arg[1000];
    int i=0,j=0;
    int num_line=1;
    char ch_line[1000];
    int child_pid=0;
    GString* plugin_file=NULL;
    GString* visual_file=NULL;
    GString* liststore_file=NULL;
    char **spawn=NULL;

    file_name=g_string_new(pwd);
    g_string_append(file_name,"/.schedio/startup/startup.conf");

    liststore_file=g_string_new(pwd);
    g_string_append(liststore_file,"/.schedio/liststore.tmp");

    spawn=malloc(4*sizeof(char*));
    spawn[0]=malloc(1000*sizeof(char));
    spawn[1]=malloc(1000*sizeof(char));
    spawn[2]=malloc(1000*sizeof(char));
    spawn[3]=NULL;

    f=fopen(file_name->str,"r");
    if(f!=NULL)
    {
        fgets(line,1000,f);
        eof=feof(f);
        while(!eof)
        {
            i=0;
            j=0;
            while(line[i]!=',' && line[i]!='\n' && line[i]!='\0')
            {
                plugin[i]=line[i];
                i++;
            }
            plugin[i]='\0';
            i++;
            while(line[i]!='\n' && line[i]!='\0')
            {
                file_arg[j]=line[i];
                j++;
                i++;
            }
            file_arg[j]='\0';
            fgets(line,1000,f);
            eof=feof(f);

            printf("F:%s %s\n",plugin,file_arg);

            plugin_file=g_string_new("/usr/share/schedio/plugin/");
            g_string_append(plugin_file,plugin);
            g_string_append(plugin_file,"/");
            g_string_append(plugin_file,plugin);

            sprintf(ch_line,"%d",num_line);

            visual_file=g_string_new(pwd);
            g_string_append(visual_file,"/.schedio/visual/visual");
            g_string_append(visual_file,ch_line);

            strcpy(spawn[0],plugin_file->str);
            strcpy(spawn[1],visual_file->str);
            strcpy(spawn[2],file_arg);

            child_pid = fork ();
            if(child_pid!=0)
            {
                // parent process
                gtk_list_store_append(liststore,treeiter);
                gtk_list_store_set (liststore, treeiter,COLUMN_PLUGIN,plugin,COLUMN_SAVE,file_arg,-1);
                f_visual=fopen(visual_file->str,"w+");
                fclose(f_visual);
                add_line(liststore_file->str,child_pid,visual_file->str);
                nb_liststore_line++;
                num_line++;
            }
            else
            {
                // new process
                execvp(plugin_file->str,spawn);

                fprintf (stderr, "an error occurred in system or process finish\n");
                abort ();
            }
            g_free(g_string_free(plugin_file,FALSE));
            g_free(g_string_free(visual_file,FALSE));
            usleep(500);
        }
    }
    free(g_string_free(file_name,FALSE));
    free(g_string_free(liststore_file,FALSE));
    free(spawn[0]);
    free(spawn[1]);
    free(spawn[2]);
    free(spawn);
    return 0;
}
