// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "visual.h"
#include "file.h"
#include "schedio.h"

void visualisation(GSList* list)
{
    FILE* f=NULL;
    int nb_line,i=0;
    GString* first;
    GString* second;
    visual.list_refresh=NULL;
    GString* file;
    GString* dir;

    GtkTreeSelection* selection;
    GtkTreeModel* treemodel;
    GtkTreeView* tree_view;
    GtkTreeIter tree_iter;
    gboolean valid;
    GtkListStore *liststore;
    gchar *str_data;
    gchar *str_data1;
    GtkTreePath *path1;
    GList* list_selected;

    int num_hbox=0;
    int num_label=0;
    int num;

    /** Récupération de la ligne du liststore **/

    liststore = (GtkListStore*)g_slist_nth_data(list,0);
    tree_view = (GtkTreeView*)g_slist_nth_data(list,2);

    selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(tree_view));
    treemodel=gtk_tree_view_get_model (GTK_TREE_VIEW(tree_view));

    valid=gtk_tree_selection_get_selected(selection,&treemodel,&tree_iter);
    list_selected=gtk_tree_selection_get_selected_rows (selection,&treemodel);
    path1=g_list_nth_data(list_selected,0);
    if(valid)
    {
        gtk_tree_model_get (liststore, &tree_iter,
                  COLUMN_PLUGIN, &str_data,
                  COLUMN_SAVE, &str_data1,
                  -1);
        num = gtk_tree_path_get_indices (path1)[0];

        /** Fabrication de la fenêtre **/

        visual.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
        gtk_container_set_border_width (GTK_CONTAINER (visual.window),2);
        gtk_window_set_title (GTK_WINDOW (visual.window), "Visualiser");
        gtk_window_set_position (GTK_WINDOW (visual.window), GTK_WIN_POS_NONE);
        gtk_window_set_icon(GTK_WINDOW(visual.window), create_pixbuf("/usr/share/pixmaps/s_schedio.png"));
        g_signal_connect (visual.window, "destroy", gtk_widget_destroy, visual.window);
        gtk_window_resize(GTK_WINDOW(visual.window),300,100);

        visual.list_refresh = g_slist_append(visual.list_refresh,(gpointer)visual.window);

        dir=g_string_new(pwd);
        g_string_append(dir,"/.schedio/liststore.tmp");
        file=get_visual_name(dir->str,num);
        free(g_string_free(dir,FALSE));

        g_slist_append(visual.list_refresh,(gpointer)file);
        //printf("%s\n",file->str);
        f=fopen(file->str,"r");
        if(f!=NULL)
        {
            fclose(f);
            nb_line = get_nb_param(file->str);
            printf("Visual lines:%d\n",nb_line);
            if(nb_line!=-1) visual.label=g_malloc(sizeof(GtkWidget*)*((nb_line+1)*2+2));
            else visual.label=g_malloc(sizeof(GtkWidget*)*2);
            if(nb_line!=-1) visual.hbox=g_malloc(sizeof(GtkWidget*)*(nb_line+1));
            else visual.hbox=g_malloc(sizeof(GtkWidget*)*(1));
            visual.vbox=gtk_vbox_new(FALSE,10);

            first=g_string_new("Nom du plugin: ");
            g_string_append(first,str_data);

            visual.label[num_label]=g_malloc(sizeof(GtkWidget));
            visual.label[num_label]=gtk_label_new(first->str);
            gtk_box_pack_start (GTK_BOX (visual.vbox), visual.label[num_label], FALSE, FALSE, 0);

            num_label++;

            free(g_string_free(first,FALSE));
            first=g_string_new("Fichier de configuration: ");
            g_string_append(first,str_data1);

            visual.label[num_label]=g_malloc(sizeof(GtkWidget));
            visual.label[num_label]=gtk_label_new(first->str);
            gtk_box_pack_start (GTK_BOX (visual.vbox), visual.label[num_label], FALSE, FALSE, 0);

            num_label++;

            free(g_string_free(first,FALSE));

            while(i<=nb_line)
            {
                first=g_string_new("");
                second=g_string_new("");
                if(extract_visual(file->str,first,second,i)==0)
                {
                    visual.label[num_label]=g_malloc(sizeof(GtkWidget));
                    visual.label[num_label]=gtk_label_new(first->str);
                    visual.hbox[num_hbox]=g_malloc(sizeof(GtkWidget));
                    visual.hbox[num_hbox]=gtk_hbox_new(FALSE,10);

                    g_slist_append(visual.list_refresh,(gpointer)visual.label[num_label]);

                    gtk_box_pack_start (GTK_BOX (visual.hbox[num_hbox]), visual.label[num_label], FALSE, FALSE, 0);

                    num_label++;

                    visual.label[num_label]=g_malloc(sizeof(GtkWidget));
                    visual.label[num_label]=gtk_label_new(second->str);

                    g_slist_append(visual.list_refresh,(gpointer)visual.label[num_label]);

                    gtk_box_pack_start (GTK_BOX (visual.hbox[num_hbox]), visual.label[num_label], FALSE, FALSE, 0);
                    gtk_box_pack_start (GTK_BOX (visual.vbox), visual.hbox[num_hbox], FALSE, FALSE, 0);

                    num_label++;
                    num_hbox++;
                }
                else
                {
                    printf("Attention, une erreur s'est produite lors de l'initialisation, il est conseillé de relancer la visualisation\n"); // Necessite une boite de dialogue
                }
                free(g_string_free(first,FALSE));
                free(g_string_free(second,FALSE));
                i++;
            }
        }
        else
        {
            printf("Erreur de lecture !"); // Necessite une boite de dialogue
        }
        if(nb_line!=-1)
        {
            visual.refresh=gtk_button_new_with_label("Rafraîchir");
            gtk_box_pack_start (GTK_BOX (visual.vbox), visual.refresh, FALSE, FALSE, 0);
            gtk_signal_connect_object(GTK_OBJECT(visual.refresh), "clicked", GTK_SIGNAL_FUNC(update_label), visual.list_refresh);
        }

        gtk_container_add(visual.window,visual.vbox);
        gtk_widget_show_all(visual.window);
    }
    else
    {
        printf("Vous devez selectionner une ligne\n"); // Necessite une boite de dialogue
    }
}

int extract_visual(char* file,GString* first,GString* second,int num)
{
    int i=0,j=0;
    FILE* f=NULL;
    char text[1000];
    char name[1000];
    char value[1000];

    f=fopen(file,"r");
    if(f==NULL) return 1;

    while(i<num)
    {
        fgets(text,1000,f);
        i++;
    }
    fgets(text,1000,f);

    i=0;
    while(text[i]!=':' && i<997)
    {
        name[i]=text[i];
        i++;
    }
    name[i]=':';
    name[i+1]='\0';
    g_string_append(first,name);

    i++;
    while(text[i]!='\n' && i<997)
    {
        value[j]=text[i];
        i++;
        j++;
    }
    value[j]='\0';
    g_string_append(second,value);

    fclose(f);

    return 0;
}

void update_label(GSList* list_refresh)
{
    int length=0;
    int nb_lines_true=0;
    int i=0;
    int j=2;
    GString* first;
    GString* second;
    GString* file;

    length=g_slist_length(list_refresh);
    nb_lines_true=(length-2)/2;

    file=g_slist_nth_data(list_refresh,1);

    if((get_nb_param(file->str)+1)==nb_lines_true)
    {
        while(i<nb_lines_true)
        {
            first=g_string_new("");
            second=g_string_new("");
            if(extract_visual(file->str,first,second,i)==0)
            {
                gtk_label_set_text(GTK_LABEL(g_slist_nth_data(list_refresh,j)),first->str);
                j++;
                gtk_label_set_text(GTK_LABEL(g_slist_nth_data(list_refresh,j)),second->str);
                j++;
            }
            else
            {
                printf("Attention, une erreur s'est produite lors de la mise à jour, il est conseillé de relancer la visualisation\n"); // Necessite une boite de dialogue
            }
            free(g_string_free(first,FALSE));
            free(g_string_free(second,FALSE));
            i++;
        }
    }
    else
    {
        printf("Erreur de compatibilité du fichier. Veuillez réessayer ou relancer la visualisation: %d\n",nb_lines_true); // Necessite une boite de dialogue
    }

}
