// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <glib.h>
#include <malloc.h>
#include <unistd.h>
#include <time.h>

char* pwd;
char inib[1000];
char prio[1000];

int spawn (char* name)
{
    pid_t child_pid;

    /* Duplicate this process. */
    child_pid = fork ();

    if (child_pid != 0)
    {
        /* This is the parent process. */
        return child_pid;
    }
    else {
    /* Now execute PROGRAM, searching for it in the path. */
    system(name);
    /* The execvp function returns only if an error occurs. */
    fprintf (stderr, "Program is close, or an error occurred in execvp\n");
    abort ();
    }
}

int get_number_row(char* path)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;

    f=fopen(path,"r");
    fgets(line,1000,f);
    eof= feof(f);

    while(eof!=1)
    {
        i++;
        fgets(line,1000,f);
        eof= feof(f);
    }
    fclose(f);

    return i;
}

int get_param(char* file,int nb,char** param)
{
    int i=0,j=0;
    char test[1000];
    FILE* f=NULL;
    f=fopen(file,"r");
    if(f!=NULL)
    {
        fgets(test,1000,f);
        while(i<nb)
        {
            if(test[0]!='#' && test[0]!='[')
            {
                while(test[j]!='\n' && test[j]!='#')
                {
                    param[i][j]=test[j];
                    j++;
                }
                param[i][j]='\0';
                i++;
                j=0;
            }
            fgets(test,1000,f);
        }
        fclose(f);
    }
    usleep(500);
    return 0;
}

GString* new_temp_name()
{
    GString* string;
    int eof=0;
    char line[1000];
    char conv[1000];
    FILE* f=NULL;
    int i=0;
    int j=7,k=0;

    string=g_string_new("mkdir ");
    g_string_append(string,pwd);
    g_string_append(string,"/.schedio/tmp/conflit");

    system(string->str);

    free(g_string_free(string,FALSE));

    string=g_string_new(pwd);
    g_string_append(string,"/.schedio/tmp/conflit.tmp");

    f=fopen(string->str,"w+");
    fclose(f);

    free(g_string_free(string,FALSE));

    string=g_string_new("ls ");
    g_string_append(string,pwd);
    g_string_append(string,"/.schedio/tmp/conflit >> ");
    g_string_append(string,pwd);
    g_string_append(string,"/.schedio/tmp/conflit.tmp");

    system(string->str);

    free(g_string_free(string,FALSE));

    string=g_string_new(pwd);
    g_string_append(string,"/.schedio/tmp/conflit.tmp");

    f=fopen(string->str,"r");

    while(!eof)
    {
        fgets(line,1000,f);
        eof=feof(f);
        i++;
    }
    fclose(f);
    if(i==1)
    {
        string=g_string_new(pwd);
        g_string_append(string,"/.schedio/tmp/conflit/conflit1");
    }
    else
    {
        while(line[j]!='\n' && line[j]!='\0')
        {
            conv[k]=line[j];
            j++;
            k++;
        }
        conv[k]='\0';
        sscanf(conv,"%d",&i);
        i++;

        sprintf(conv,"%d",i);
        string=g_string_new(pwd);
        g_string_append(string,"/.schedio/tmp/conflit/conflit");
        g_string_append(string,conv);
    }
    return string;
}

int main(int argc, char *argv[])
{
    FILE* f_visual=NULL;
    FILE* f_save=NULL;
    int nb_row=0;

    char* cmdpid=NULL;
    char** args=NULL;
    GString* temp_name;
    GString* cmd_kill=NULL;
    int i=0,j=0,k=0;
    int relaunch=0;
    int prio_on=0;
    int inib_on=0;
    int was_launch=0;
    int is_to_launch=0;
    int nb_lines=0;

    long int nb_verifs=0;
    long int nb_bloc=0;
    long int nb_relaunch=0;

    time_t timestamp;
    char buffer[256];

    char path[1000];
    char line[1000];
    char str_nb[10];

    FILE* f_temp=NULL;

    /** INIT **/

    pwd = getenv ("HOME");
    temp_name=new_temp_name();

    printf("Temp_name:%s\n",temp_name->str);

    /** FIRST TEST **/

    printf("ARGC=%d\n",argc);
    if(argc==3)
    {
        f_visual=fopen(argv[1],"w+");

        fprintf(f_visual,"État:Actif\n");
        fprintf(f_visual,"Nombre de vérifications:0\n");
        fprintf(f_visual,"Nombre de blocages:0\n");
        fprintf(f_visual,"Nombre de relancements:0\n");
        fprintf(f_visual,"Dernière vérification:--:--:--\n");
        fprintf(f_visual,"Programme prioritaire lancé:non\n");
        fprintf(f_visual,"Programme inhibé lancé:non");

        fclose(f_visual);
        strcpy(path,argv[2]);
    }

    nb_row=get_number_row(path);
    printf("Nb_row:%d\n",nb_row);

    /** MAIN LOOP **/

    if(nb_row==4 && argc==3)
    {
        printf("Loop begin\n");

        args=malloc(4*sizeof(char*));

        i=0;
        while(i<4)
        {
            args[i]=malloc(1000*sizeof(char));
            i++;
        }

        while(1)
        {
            /** FILE VERIF **/

            nb_row=get_number_row(path);
            printf("Nb_row:%d\n",nb_row);

            if(nb_row==4)
            {

                /** Core **/

                printf("Next\n");
                get_param(path,3,args);

                strcpy(prio,args[0]);
                strcpy(inib,args[1]);

                printf("1:%s\n",prio);
                printf("2:%s\n",inib);

                if(args[2][0]=='1') relaunch=1;

                if(relaunch==0) is_to_launch=0;

                printf("Relancement:%d\n",relaunch);

                cmdpid = (char*)malloc(sizeof(char)*(strlen("ps -eo pid,command | grep -v grep | grep -v defunct | grep ")+strlen(prio)+1+strlen(" > ")+strlen(temp_name->str)));
                strcpy(cmdpid,"ps -eo pid,command | grep -v grep | grep -v defunct | grep ");
                strcat(cmdpid,prio);
                strcat(cmdpid," > ");
                strcat(cmdpid,temp_name->str);
                system(cmdpid);
                free(cmdpid);

                if(get_number_row(temp_name->str))
                {
                    printf("Prio is ON\n");
                    prio_on=1;
                }
                else printf("Prio is OFF\n");

                cmdpid = (char*)malloc(sizeof(char)*(strlen("ps -eo pid,command | grep -v grep | grep -v defunct | grep ")+strlen(inib)+1+strlen(" > ")+strlen(temp_name->str)));
                strcpy(cmdpid,"ps -eo pid,command | grep -v grep | grep -v defunct | grep ");
                strcat(cmdpid,inib);
                strcat(cmdpid," > ");
                strcat(cmdpid,temp_name->str);
                system(cmdpid);
                free(cmdpid);

                if(get_number_row(temp_name->str))
                {
                    printf("Inib is ON\n");
                    nb_lines=get_number_row(temp_name->str);
                    inib_on=1;
                }
                else printf("Inib is OFF\n");

                if(inib_on && prio_on)
                {
                    printf("Conflit detected !\n");

                    f_temp=fopen(temp_name->str,"r");

                    if(f_temp!=NULL)
                    {
                        i=0;
                        while(i<nb_lines)
                        {
                            j=0;
                            k=0;

                            fgets(line,1000,f_temp);

                            while(((line[j]<48) || (line[j]>57)) && (j<1000)) j++;

                            while(line[j]!=' ')
                            {
                                str_nb[k]=line[j];
                                j++;
                                k++;
                            }

                            str_nb[k]='\0';

                            printf("Numpid%d: %s\n",i,str_nb);

                            cmd_kill=g_string_new("kill -15 ");
                            g_string_append(cmd_kill,str_nb);

                            system(cmd_kill->str);

                            free(g_string_free(cmd_kill,FALSE));

                            i++;
                        }
                        fclose(f_temp);

                        if(relaunch==1)is_to_launch=1;
                        nb_bloc++;
                    }
                    else printf("Erreur ! Résolution du conflit impossible !\n");

                    f_temp=NULL;
                }
                printf("%d : %d\n",was_launch,is_to_launch);

                if((!prio_on) && is_to_launch && was_launch )
                {
                    is_to_launch=0;
                    was_launch=0;
                    spawn(inib);
                    nb_relaunch++;
                }

                if(inib_on && (!prio_on))
                {
                    was_launch=1;
                }

                if((!inib_on) && (!prio_on))
                {
                    was_launch=0;
                    is_to_launch=0;
                }

                nb_verifs++;
                if(nb_verifs<0) nb_verifs=0;

                timestamp = time(NULL);

                strftime(buffer, sizeof(buffer), "%d/%m/%y - %X", localtime(&timestamp));

                /** VISUALISATION FILE **/

                f_visual=fopen(argv[1],"w+");

                fprintf(f_visual,"État:Actif\n");
                fprintf(f_visual,"Nombre de vérifications:%d\n",nb_verifs);
                fprintf(f_visual,"Nombre de blocages:%d\n",nb_bloc);
                fprintf(f_visual,"Nombre de relancements:%d\n",nb_relaunch);
                fprintf(f_visual,"Dernière vérification:%s\n",buffer);

                if(prio_on) fprintf(f_visual,"Programme prioritaire lancé:oui\n");
                else fprintf(f_visual,"Programme prioritaire lancé:non\n");

                if(inib_on)fprintf(f_visual,"Programme inhibé lancé:oui");
                else fprintf(f_visual,"Programme inhibé lancé:non");

                fclose(f_visual);

                /** END OF LOOP **/

                prio_on=0;
                inib_on=0;
                relaunch=0;

                sleep(1);
            }
            else break;
        }
        i=0;
        while(i<4)
        {
            free(args[i]);
            i++;
        }
        free(args);
    }
    return 0;
}
