// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "file.h"
#include "plugin.h"
#include <gtk/gtk.h>

int set_param(char* file, char* name, int nb, GSList* gslist)
{
    int i=0;
    FILE* f = NULL;
    f=fopen(file,"a+");
    fprintf(f,"[%s]\n",name);
    while(i<nb)
    {
        fprintf(f,"%s\n",(char*)g_slist_nth_data (gslist, i));
        i++;
    }
    fclose(f);
    return 0;
}

int get_nb_param(char* file)
{
    int i=0;
    int eof=0;
    char test[1000];
    FILE* f=NULL;
    f=fopen(file,"r");
    fgets(test,1000,f);
    eof=feof(f);
    while(!eof)
    {
        if(test[0]!='#') i++;
        fgets(test,1000,f);
        eof=feof(f);
    }
    fclose(f);
    return i;
}
int get_param(char* file,int nb,char** param)
{
    int i=0,j=0;
    char test[1000];
    FILE* f=NULL;
    f=fopen(file,"r");
    fgets(test,1000,f);
    while(i<nb)
    {
        if(test[0]!='#' && test[0]!='[')
        {
            while(test[j]!='\n' && test[j]!='#')
            {
                param[i][j]=test[j];
                j++;
            }
            param[i][j]='\0';
            i++;
            j=0;
        }
        fgets(test,1000,f);
    }
    fclose(f);
    usleep(500);
    return 0;
}

int add_line(char* file,int pid,char* name)
{
    FILE* f=NULL;
    int eof=0;
    int nb=0;
    char save[1000];

    f=fopen(file,"r");
    if(f!=NULL)
    {
        nb=fgets(save,1000,f);
        printf("%d",nb);
        fclose(f);
    }
    if(nb==0) eof=1;
    else eof=0;

    f=fopen(file,"a");
    if(f!=NULL)
    {
        printf("%s %d,%s\n",file,pid,name);
        if(eof) fprintf(f,"%d,%s",pid,name);
        else fprintf(f,"\n%d,%s",pid,name);
        fclose(f);
        return 0;
    }
    else
    {
        printf("ERROR WHILE WRITING");
        return 1;
    }
}

int modify_line(char* file,int line,int pid)
{
    FILE* f=NULL;
    FILE* f1=NULL;
    char save[1000];
    char save1[1000];
    int eof=0;
    int i=0;
    int j=0,k=0;
    GString* cmd=NULL;

    cmd=g_string_new("cp '");
    g_string_append(cmd,file);
    g_string_append(cmd,"' '");
    g_string_append(cmd,file);
    g_string_append(cmd,"1'");
    system(cmd->str);

    free(g_string_free(cmd,FALSE));

    cmd=g_string_new(file);
    g_string_append(cmd,"1");
    f1=fopen(cmd->str,"r");

    free(g_string_free(cmd,FALSE));

    f=fopen(file,"w+");
    fgets(save,1000,f1);
    while(!eof)
    {
        eof=feof(f1);
        if(i==line)
        {
            while(save[j]!=',') j++;
            j++;
            while(save[j]!='\n' && save[j]!='\0')
            {
                save1[k]=save[j];
                j++;
                k++;
            }
            if(!eof)
            {
                save1[k]='\n';
                k++;
            }
            save1[k]='\0';
            fprintf(f,"%d,%s",pid,save1);
        }
        else
        {
            fprintf(f,"%s",save);
        }
        i++;
        fgets(save,1000,f1);
    }
    fclose(f);
    fclose(f1);
    return 0;
}

int del_line(char* file,int line)
{
    FILE* f=NULL;
    FILE* f1=NULL;
    char save[1000];
    int eof=0;
    int i=0;
    GString* cmd=NULL;

    cmd=g_string_new("cp '");
    g_string_append(cmd,file);
    g_string_append(cmd,"' '");
    g_string_append(cmd,file);
    g_string_append(cmd,"1'");
    system(cmd->str);

    free(g_string_free(cmd,FALSE));

    cmd=g_string_new(file);
    g_string_append(cmd,"1");
    f1=fopen(cmd->str,"r");

    free(g_string_free(cmd,FALSE));

    f=fopen(file,"w+");
    fgets(save,1000,f1);
    while(!eof)
    {
        printf("%d : %s\n",i,save);
        if(i!=line)
        {
            fprintf(f,"%s",save);
        }
        i++;
        eof=feof(f1);
        fgets(save,1000,f1);
    }
    fclose(f);
    fclose(f1);
    return 0;
}

GString* new_visual_name()
{
    GString* string;
    int eof=0;
    char line[1000];
    char conv[1000];
    FILE* f=NULL;
    int i=0;
    int j=6,k=0;

    string=g_string_new(pwd);
    g_string_append(string,"/.schedio/tmp/visual.tmp");

    f=fopen(string->str,"w+");
    fclose(f);

    free(g_string_free(string,FALSE));

    string=g_string_new("ls ");
    g_string_append(string,pwd);
    g_string_append(string,"/.schedio/visual >> ");
    g_string_append(string,pwd);
    g_string_append(string,"/.schedio/tmp/visual.tmp");

    system(string->str);

    free(g_string_free(string,FALSE));

    string=g_string_new(pwd);
    g_string_append(string,"/.schedio/tmp/visual.tmp");

    f=fopen(string->str,"r");

    while(!eof)
    {
        fgets(line,1000,f);
        eof=feof(f);
        i++;
    }
    fclose(f);
    if(i==1)
    {
        string=g_string_new(pwd);
        g_string_append(string,"/.schedio/visual/visual1");
    }
    else
    {
        while(line[j]!='\n' && line[j]!='\0')
        {
            conv[k]=line[j];
            j++;
            k++;
        }
        conv[k]='\0';
        sscanf(conv,"%d",&i);
        i++;

        sprintf(conv,"%d",i);
        string=g_string_new(pwd);
        g_string_append(string,"/.schedio/visual/visual");
        g_string_append(string,conv);
    }
    return string;
}

GString* get_visual_name(char* file,int line)
{
    FILE* f=NULL;
    char save[1000];
    char save1[1000];
    int i=0;
    int j=0;
    GString* string=NULL;

    f=fopen(file,"r");
    while(i<line)
    {
        fgets(save,1000,f);
        i++;
    }
    fgets(save,1000,f);
    i=0;
    while(save[i]!=',') i++;
    i++;
    while(save[i]!='\n' && save[i]!='\0')
    {
        save1[j]=save[i];
        i++;
        j++;
    }
    save1[j]='\0';

    fclose(f);
    string=g_string_new(save1);
    printf("FOUND:%s\n",string->str);

    return string;
}

int get_visual_name_row(char* file,char* name)
{
    int row=0,ok=0,compok=1;
    FILE* f=NULL;
    char save[1000];
    int eof=0;
    int i=0;
    int j=0;
    int nb=0;

    f=fopen(file,"r");
    eof=feof(f);
    if(f!=NULL)
    {
        nb=fgets(save,1000,f);
        while(!eof && !ok && nb)
        {
            i=0;
            j=0;
            compok=1;
            while(save[i]!=',') i++;
            i++;
            while(i<strlen(save) && j<strlen(name) && compok)
            {
                if(name[j]==save[i]) compok=1;
                else compok=0;
                i++;
                j++;
            }
            if(compok)
            {
                printf("ROW FOUND AT LINE %d\n",row);
                ok=1;
            }
            row++;
            eof=feof(f);
            if(!eof)nb=fgets(save,1000,f);
        }
        if(ok==0)
        {
            printf("ROW NOT FOUND\n");
            row=-1;
        }
        else row--;
        fclose(f);
    }
    return row;
}

int get_pid(char *file,int line)
{
    FILE* f=NULL;
    char save[1000];
    char conv[1000];
    int i=0;
    int j=0;
    int pid=0;

    f=fopen(file,"r");
    while(i<line)
    {
        fgets(save,1000,f);
        i++;
    }
    fgets(save,1000,f);
    i=0;
    while(save[i]!=',')
    {
        conv[j]=save[i];
        i++;
        j++;
    }
    conv[j]='\0';
    fclose(f);

    sscanf(conv,"%d",&pid);

    printf("PID:%d\n",pid);
    return pid;
}
